net.corda.contracts

## Class Clauses.Issue

- Clause
- - AbstractIssue
  - - net.corda.contracts.CommercialPaper.Clauses.Issue

- Enclosing interface:
    CommercialPaper.Clauses

      public static class Clauses.Issue
      extends AbstractIssue

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class net.corda.core.contracts.clauses.Clause

      `Clause.Companion`

  - ### Field Summary

    - ### Fields inherited from class net.corda.core.contracts.clauses.Clause

      `Companion`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Issue()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.Set<java.lang.Class>` | `getRequiredCommands()` Determine whether this clause runs or not
    `java.util.Set<net.corda.contracts.CommercialPaper.Commands>` | `verify(TransactionForContract tx, java.util.List<net.corda.contracts.CommercialPaper.State> inputs, java.util.List<net.corda.contracts.CommercialPaper.State> outputs, java.util.List<? extends net.corda.core.contracts.AuthenticatedObject<? extends net.corda.contracts.CommercialPaper.Commands>> commands, Issued<net.corda.contracts.CommercialPaper.Terms> groupingKey)` Verify the transaction matches the conditions from this clause. For example, a "no zero amount output" clause would check each of the output states that it applies to, looking for a zero amount, and throw IllegalStateException if any matched.

    - ### Methods inherited from class net.corda.contracts.clause.AbstractIssue

      `getSum, getSumOrZero, verify`

    - ### Methods inherited from class net.corda.core.contracts.clauses.Clause

      `getExecutionPath, getRequiredCommands, verify`

- - ### Constructor Detail

    - #### Issue

          public Issue()

  - ### Method Detail

    - #### getRequiredCommands

          public java.util.Set<java.lang.Class> getRequiredCommands()

      Determine whether this clause runs or not

    - #### verify

          public java.util.Set<net.corda.contracts.CommercialPaper.Commands> verify(TransactionForContract tx,
                                                                                    java.util.List<net.corda.contracts.CommercialPaper.State> inputs,
                                                                                    java.util.List<net.corda.contracts.CommercialPaper.State> outputs,
                                                                                    java.util.List<? extends net.corda.core.contracts.AuthenticatedObject<? extends net.corda.contracts.CommercialPaper.Commands>> commands,
                                                                                    Issued<net.corda.contracts.CommercialPaper.Terms> groupingKey)

      Verify the transaction matches the conditions from this clause. For example, a "no zero amount output" clause would check each of the output states that it applies to, looking for a zero amount, and throw IllegalStateException if any matched.

      Parameters:
        `tx` - the full transaction being verified. This is provided for cases where clauses need to access states or commands outside of their normal scope.
        `inputs` - input states which are relevant to this clause. By default this is the set passed into verifyClause, but may be further reduced by clauses such as `class GroupClauseVerifier`.
        `outputs` - output states which are relevant to this clause. By default this is the set passed into verifyClause, but may be further reduced by clauses such as `class GroupClauseVerifier`.
        `commands` - commands which are relevant to this clause. By default this is the set passed into verifyClause, but may be further reduced by clauses such as `class GroupClauseVerifier`.
        `groupingKey` - a grouping key applied to states and commands, where applicable. Taken from `class TransactionForContract.InOutGroup`.
      Returns:
        the set of commands that are consumed IF this clause is matched, and cannot be used to match a later clause. This would normally be all commands matching "requiredCommands" for this clause, but some verify() functions may do further filtering on possible matches, and return a subset. This may also include commands that were not required (for example the Exit command for fungible assets is optional).